/*
	giAvŃtB[hRPGEbZ[W\EChE

	2011-05-04 nvO~O̊X
*/

import com.nttdocomo.ui.*;
import java.util.*;

// bZ[W\EChE
public class m11RPGid_MessageWindow {

	public static final int DEFAULT_BORDER_SIZE = 1;
	public static final int DEFAULT_CONTENT_PADDING = 2;
	public static final int DEFAULT_WIDTH = 160;
	public static final int DEFAULT_HEIGHT = 100;

	public static final int DEFAULT_LINE_HEIGHT = 18;

	public static final int PROCESS_STAGE_NONE = 0;
	public static final int PROCESS_STAGE_PUTTING = 1;
	public static final int PROCESS_STAGE_PAGE_WAIT = 2;
	public static final int PROCESS_STAGE_PAGE_START = 3;
	public static final int PROCESS_STAGE_PAGE_END = 4;
	public static final int PROCESS_STAGE_PAGE_EXIT = 5;
	public static final int PROCESS_STAGE_MESSAGE_EXIT = 6;
	public static final int PROCESS_STAGE_EXIT = 7;

	// \ʒu
	private int _x = 0;
	private int _y = 0;

	// EChȆ傫
	private int _width = 0;
	private int _height = 0;

	// OgTCY
	private int _border_size = DEFAULT_BORDER_SIZE;

	// g̈̍W
	private int _inner_x = 0;
	private int _inner_y = 0;

	// g̈̑傫
	private int _inner_width = 0;
	private int _inner_height = 0;

	// g]
	private int _content_padding = DEFAULT_CONTENT_PADDING;

	// \̈捶W
	private int _content_x = 0;
	private int _content_y = 0;

	// \̈̑傫
	private int _content_width = 0;
	private int _content_height = 0;

	// 1y[W̕\s
	private int _page_lines = 0;

	// `tHg
	private Font _font = Font.getDefaultFont();;

	// s̍
	private int _line_height = DEFAULT_LINE_HEIGHT;

	// \iy[Wzj
	private String[][] _pageList = null;

	private  int _process_stage = 0;
	private  int _process_count = 0;

	// ݃y[W
	private int _page_index = 0;

	// ݕ\ʒu
	private  int _putting_line = 0;
	private  int _putting_pos = 0;

	// i`jtO
	private  boolean _visible = false;

	private int[] _cursorShapeX = new int[3];
	private int[] _cursorShapeY = new int[3];

	public m11RPGid_MessageWindow() {

		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);

	}

	// `掞XW擾
	public int getX() {
		return _x;
	}

	// `掞YW擾
	public int getY() {
		return _y;
	}

	// `掞̉擾
	public int getWidth() {
		return _width;
	}

	// `掞̍擾
	public int getHeight() {
		return _height;
	}

	// EChȆ傫ݒ
	public boolean setSize(int width, int height) {

		if (width < ((_border_size * 2) + (_content_padding * 2)) || height < ((_border_size * 2) + (_content_padding * 2))) {
			return false;
		}

		// EChEŜ̑傫ۑ
		_width = width;
		_height = height;

		// g̈̑傫vZ
		_inner_width = _width - (_border_size * 2);
		_inner_height = _height - (_border_size * 2);

		// \̈̑傫vZ
		_content_width = _inner_width - (_content_padding * 2);
		_content_height = _inner_height - (_content_padding * 2);

		// 1y[W̍svZ
		_page_lines = _content_height / _line_height;

		return true;

	}

	// \ʒuݒ
	public void setPos(int x, int y) {

		_x = x;
		_y = y;

		_inner_x = x + _border_size;
		_inner_y = y + _border_size;

		_content_x = _inner_x + _content_padding;
		_content_y = _inner_y + _content_padding;

	}

	// Ԃ
	public void show() {
		_visible = true;
	}

	// sԂ
	public void hide() {
		_visible = false;
	}

	// \ݒ
	public void setText(String text) {

		int i;

		Vector lineVector = new Vector();
		String line = new String();

		int pos = 0;
		boolean page_flag;

		// EChẺɍ킹Ċes̃eLXg쐬
		while (pos < text.length()) {

			// y[WtOZbg
			page_flag = false;

			// ̕`敝EChE𒴂܂Ōݍsɕǉ
			while (pos < text.length() && _font.stringWidth(line + text.charAt(pos)) < _content_width) {

				// ݈ʒu<:br>^OΉs݈ʒu^O̎̕
				if (text.indexOf("<:br>", pos) == pos) {

					pos += 5;

					// ݍs̏I
					break;

				}

				// ݈ʒu<:page>^OΉy[W
				if (text.indexOf("<:page>", pos) == pos) {

					pos += 7;

					// y[WtOZbg
					page_flag = true;

					// ݍs̏I
					break;

				}

				// ݍsɌ݈ʒu̕ǉ
				line = line + text.charAt(pos);

				// ݈ʒuXV
				pos++;

			}

			// ݍs̕szɒǉ
			lineVector.addElement(line);

			// y[WtOZbgĂy[W}
			if (page_flag) {
				lineVector.addElement("\f");
			}

			// ݍs̕
			line = new String();

		}

		String[] lineList = new String[lineVector.size()];

		for (i = 0;i < lineVector.size();i++) {
			lineList[i] = new String((String)(lineVector.elementAt(i)));
		}

		Vector pageList = new Vector();

		// o͒̕ʒu
		int page_pos = 0;
		int line_pos = 0;

		// szy[WzɊi[
		while (line_pos < lineList.length) {

			// Vy[W쐬
			pageList.addElement(new Vector());

			// y[Wž݃y[Wɍsz̊esǉ
			for (i = 0;(i < _page_lines) && (line_pos < lineList.length);i++) {

				// y[W
				if (lineList[line_pos].length() > 0 && lineList[line_pos].charAt(0) == '\f') {

					// ݍsʒuy[Ws̎
					line_pos++;

					// y[W擪łȂΉy[Ws
					if (i > 0) {

						// ݃y[WIVKy[W
						break;

					}

				} else {

					// y[Wž݈ʒuɍsz̕Rs[
					((Vector)pageList.elementAt(page_pos)).addElement(lineList[line_pos++]);

				}

			}

			page_pos++;

		}

		_pageList = new String[pageList.size()][];

		for (i = 0;i < pageList.size();i++) {

			int page_lines = ((Vector)(pageList.elementAt(i))).size();

			_pageList[i] = new String[page_lines];

			Vector pageLineList = (Vector)pageList.elementAt(i);

			for (int j = 0;j < _pageList[i].length;j++) {

				_pageList[i][j] = new String((String)(pageLineList.elementAt(j)));

			}

		}

		// Ԃ𒀎o͂
		this._process_stage = PROCESS_STAGE_PUTTING;

		// ݃y[Wʒuŏ̃y[W
		this._page_index = 0;

		// ݕ\ʒu
		this._putting_line = 0;
		this._putting_pos = 0;

	}

	// y[WŜ\
	public void pageDone() {

		if (_process_stage == PROCESS_STAGE_PUTTING) {
			_process_stage = PROCESS_STAGE_PAGE_END;
		}

	}

	// 莞
	public boolean process(m11RPGid_KeyStatusHolder key) {

		switch (_process_stage) {

		// y[WJn
		case PROCESS_STAGE_PAGE_START:

			// ^[L[ҋ@Ƀy[W\Jn
			if (key.getTrigger() == 0) {

				_putting_line = 0;
				_putting_pos = 0;

				_process_stage = PROCESS_STAGE_PUTTING;

			}

			break;

		// y[W\
		case PROCESS_STAGE_PAGE_END:

			// ^[L[ҋ@Ƀy[W^bZ[WI
			if (key.getTrigger() == 0) {
				if (_page_index < _pageList.length - 1) {
					_process_stage = PROCESS_STAGE_PAGE_EXIT;
				} else {
					_process_stage = PROCESS_STAGE_MESSAGE_EXIT;
				}
			}

			break;

		// y[WI
		case PROCESS_STAGE_PAGE_EXIT:

			// ^[L[ĂAy[WJn
			if (key.getTrigger() == m11RPGid_KeyStatusHolder.KEYFLAG_SELECT) {

				_page_index++;

				_process_stage = PROCESS_STAGE_PAGE_START;

			}

			break;

		// bZ[WiSy[WjI
		case PROCESS_STAGE_MESSAGE_EXIT:

			// ^[L[ĂAIԂ
			if (key.getTrigger() == m11RPGid_KeyStatusHolder.KEYFLAG_SELECT) {
				_process_stage = PROCESS_STAGE_EXIT;
			}

			break;

		// y[W񒀎o͒
		case PROCESS_STAGE_PUTTING:

			// \ʒuXV
			_putting_pos++;

			// s̕\I
			if (_putting_pos >= _pageList[_page_index][_putting_line].length()) {

				// y[WSs̕\Ȃy[WI
				if (_putting_line == _pageList[_page_index].length - 1) {
					_process_stage = PROCESS_STAGE_PAGE_END;
				} else {

					// ̍s
					_putting_line++;
					_putting_pos = 0;

				}

			}

			// ^[L[Ăy[WS\
			if (_process_stage == PROCESS_STAGE_PUTTING && key.getTrigger() == m11RPGid_KeyStatusHolder.KEYFLAG_SELECT) {
				_process_stage = PROCESS_STAGE_PAGE_END;
			}

			break;

		}

		_process_count++;

		// \IԂȂtrue
		return _process_stage == PROCESS_STAGE_EXIT;

	}

	// bZ[W\_CAO`֐
	public void draw(Graphics g) {

		int i;

		// ԂłȂΕ`揈͍sȂ
		if (!this._visible) {
			return;
		}

		// EChËŜ𔒂ŃNA
		g.setColor(g.getColorOfRGB(255, 255, 255));
		g.fillRect(_x, _y, _width, _height);

		// ŃNA
		g.setColor(g.getColorOfRGB(0, 0, 0));
		g.fillRect(_inner_x, _inner_y, _inner_width, _inner_height);

		// `Fݒ
		g.setColor(g.getColorOfRGB(255, 255, 255));

		// `ptHgݒ
		g.setFont(_font);

		int font_height = _font.getHeight();

		switch (_process_stage) {

		// y[W񒀎o͒
		case PROCESS_STAGE_PUTTING:

			// ݍs̑O܂ňCɏo
			for (i = 0;i < _putting_line;i++) {
				g.drawString(_pageList[_page_index][i], _content_x, font_height + _content_y + i * _line_height);
			}

			// ݕ\̍s̕\ʒu̕܂ŕ`
			g.drawString(_pageList[_page_index][_putting_line].substring(0, _putting_pos), _content_x, font_height + _content_y + i * _line_height);

			break;

		// y[WS̕\
		case PROCESS_STAGE_PAGE_END:
		case PROCESS_STAGE_PAGE_EXIT:
		case PROCESS_STAGE_MESSAGE_EXIT:

			// ݃y[Wɂsz̕`
			for (i = 0;i < _pageList[_page_index].length;i++) {
				g.drawString(_pageList[_page_index][i], _content_x, font_height + _content_y + i * _line_height);
			}

			break;

		}

		// y[Wҋ@ȂAy[W}[J[_ŕ\
		if (_process_stage == PROCESS_STAGE_PAGE_EXIT && (_process_count % 16) < 8) {

			// `̈XSWZo
			int content_center_x = _content_x + (_content_width / 2);

			_cursorShapeX[0] = content_center_x - 5;
			_cursorShapeY[0] = _content_y + _content_height - 8;

			_cursorShapeX[1] = content_center_x + 5;
			_cursorShapeY[1] = _content_y + _content_height - 8;

			_cursorShapeX[2] = content_center_x;
			_cursorShapeY[2] = _content_y + _content_height - 1;

			// ݂̑IʒuɃJ[\`
			g.fillPolygon(_cursorShapeX, _cursorShapeY, 3);

		}

	}

}
