public class m11RPGid_ScriptCode {

	public final static int SCRIPTCODE_NONE = 0;
	public final static int SCRIPTCODE_IF = 1;
	public final static int SCRIPTCODE_ELSE = 2;
	public final static int SCRIPTCODE_ENDIF = 3;
	public final static int SCRIPTCODE_SUM = 4;
	public final static int SCRIPTCODE_ADD = 5;
	public final static int SCRIPTCODE_SUB = 6;
	public final static int SCRIPTCODE_MUL = 7;
	public final static int SCRIPTCODE_DIV = 8;
	public final static int SCRIPTCODE_SQRT = 9;
	public final static int SCRIPTCODE_RAND = 10;
	public final static int SCRIPTCODE_GETVAR = 11;
	public final static int SCRIPTCODE_SETVAR = 12;
	public final static int SCRIPTCODE_EQ = 13;
	public final static int SCRIPTCODE_NE = 14;
	public final static int SCRIPTCODE_LT = 15;
	public final static int SCRIPTCODE_GT = 16;
	public final static int SCRIPTCODE_LE = 17;
	public final static int SCRIPTCODE_GE = 18;
	public final static int SCRIPTCODE_AND = 19;
	public final static int SCRIPTCODE_OR = 20;
	public final static int SCRIPTCODE_MOVE = 21;
	public final static int SCRIPTCODE_MESSAGE = 22;
	public final static int SCRIPTCODE_SELECT = 23;
	public final static int SCRIPTCODE_BATTLE = 24;
	public final static int SCRIPTCODE_REG_BATTLE = 25;
	public final static int SCRIPTCODE_IMAGE = 26;
	public final static int SCRIPTCODE_SETBGM = 27;
	public final static int SCRIPTCODE_STOPBGM = 28;
	public final static int SCRIPTCODE_PLAYVIDEO = 29;
	public final static int SCRIPTCODE_FLASH = 30;
	public final static int SCRIPTCODE_ADDITEM = 31;
	public final static int SCRIPTCODE_DECITEM = 32;
	public final static int SCRIPTCODE_GETITEMNUM = 33;
	public final static int SCRIPTCODE_GETITEMSPACE = 34;
	public final static int SCRIPTCODE_GETPLAYERSTATUS = 35;
	public final static int SCRIPTCODE_SETPLAYERSTATUS = 36;
	public final static int SCRIPTCODE_GETENEMYSTATUS = 37;
	public final static int SCRIPTCODE_GETLOCALVAR = 38;
	public final static int SCRIPTCODE_SETLOCALVAR = 39;
	public final static int SCRIPTCODE_END = 40;
	public final static int SCRIPTCODE_SETCHAR = 41;

	public int code;

	public String[] argList;

	public m11RPGid_ScriptCode() {

		code = SCRIPTCODE_NONE;

		argList = null;

	}

	public m11RPGid_ScriptCode(m11RPGid_ScriptCode arg) {

		code = SCRIPTCODE_NONE;

		argList = null;

		if (arg == null) {
			return;
		}

		code = arg.code;

		argList = arg.copyArgList();

	}

	public String[] copyArgList() {

		if (argList == null || argList.length < 1) {
			return null;
		}

		String[] list = new String[argList.length];

		for (int i = 0;i < argList.length;i++) {
			list[i] = new String(argList[i]);
		}

		return list;

	}

}
